/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.dao.orm.custom.sql;

import com.liferay.petra.concurrent.ConcurrentReferenceKeyHashMap;
import com.liferay.petra.memory.FinalizeManager;

import java.util.HashMap;
import java.util.Map;

import org.osgi.framework.BundleContext;

/**
 * @author     Peter Fellwock
 * @deprecated As of Judson, with no direct replacement
 */
@Deprecated
public class CustomSQLPool {

	public CustomSQLPool() {
		_maps = new ConcurrentReferenceKeyHashMap<>(
			FinalizeManager.WEAK_REFERENCE_FACTORY);
	}

	public void clear() {
		_maps = null;

		_maps = new ConcurrentReferenceKeyHashMap<>(
			FinalizeManager.WEAK_REFERENCE_FACTORY);
	}

	public String get(BundleContext bundleContext, String id) {
		Map<String, String> map = _maps.get(bundleContext);

		if (map != null) {
			return map.get(id);
		}

		return null;
	}

	public String get(Map<String, String> map, String id) {
		return map.get(id);
	}

	public String get(String id) {
		for (Map.Entry<BundleContext, Map<String, String>> entry :
				_maps.entrySet()) {

			if (entry.getKey() == null) {
				continue;
			}

			Map<String, String> map = entry.getValue();

			if (map == null) {
				continue;
			}

			String content = map.get(id);

			if (content != null) {
				return content;
			}
		}

		return null;
	}

	public boolean isBundleContextLoaded(BundleContext bundleContext) {
		Map<String, String> map = _maps.get(bundleContext);

		if (map != null) {
			return true;
		}

		return false;
	}

	public void put(BundleContext bundleContext, String id, String content) {
		Map<String, String> map = _maps.get(bundleContext);

		if (map == null) {
			map = new HashMap<>();

			_maps.put(bundleContext, map);
		}

		map.put(id, content);
	}

	private static Map<BundleContext, Map<String, String>> _maps =
		new ConcurrentReferenceKeyHashMap<>(
			FinalizeManager.WEAK_REFERENCE_FACTORY);

}